import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class TaskCVar2 {
    private static ArrayList<Integer>[] g;
    private static boolean[] used;
    private static boolean isCycle;
    private static int kol, pred;
    private static void dfs(int v){
        used[v]=true;
        kol++;
        for(int i =0 ; i<g[v].size(); i++){
            int to = g[v].get(i);
            if(!used[to]){
                pred = v;
                dfs(to);
            }
            else{
                if(to!=pred){
                    isCycle=false;
                }
            }
        }
    }
    public void solve() throws IOException {
        int n = nextInt();
        used = new boolean[n];
        g =new ArrayList[n];
        for(int i =0 ; i<n; i++){
            g[i] = new ArrayList<>();
        }
        for(int i= 0 ; i<n; i++){
            int x = nextInt()-1;
            if(x!=-2){
                g[i].add(x);
                g[x].add(i);
            }
        }
        int res = 0;
        for(int i =0 ; i<n; i++){
            if(!used[i]){
                kol = 0;
                isCycle=false;
                dfs(i);
                if(isCycle){
                    res+=kol/2;
                }
                else {
                    res+=(kol+1)/2;
                }
            }
        }
        System.out.println(res);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskCVar2().run();
    }
}
